/* based on the tutorial for the PE / C68 */
/* No benefit should be done with this soft */
/* This program is free : no charge, even for copying or anything else */
/* Any alteration is at your own risk */
/* Any use too! */

#include <stdlib.h>
#include <stdio.h>
#include <qdos.h>
#include <qptr.h>
#include <string.h>
#include <libsprt.h>
#include <xmenu.h>
#include <fcntl.h>
#include <unistd.h>

#include "main.h"

typedef struct
{
  unsigned char flag;
  unsigned char type[3];
  unsigned long start;
  unsigned long length;
} partition;
typedef struct
{
   unsigned short tag;
   char           first_fill[340];
   partition icd_part[8];
   char           second_fill[16];
   partition classic_part[4];
   char           last_fill[10];
} sector;
static
long wm_vectr=0;
long sectornumber = 0;
static short my_sprite[]={8,9,10};
                                    /* for new C68 , use _condetails.. */

struct WINDOWDEF _condetails = 
                    { (char) 0,(char) 0,(char)0,(char)4 ,
                      (short)2,(short)1,(short)0,(short)0};

unsigned int dis_x,dis_y;
char _conname[] = "con_2x1a0x0";      /* mask startup problems, for old one */
char *_endmsg  = NULL;                /* and stop when I say */
#define JG_PROG_NAME "Q40 Partition"
char _PROG_NAME[] = JG_PROG_NAME;

static long ACOEUR(), AMOVE(), ARESIZE(), AZZZ(), AWAKE(),AUPDATE();

static long ATI();
struct WM_action acoeur = {JSR, wm_actli, ACOEUR};
struct WM_action amove = {JSR, wm_actli, AMOVE};
struct WM_action awake = {JSR, wm_actli, AWAKE};
struct WM_action aupdate = {JSR, wm_actli, AUPDATE};

struct WM_action azzz = {JSR, wm_actli, AZZZ};
struct WM_action aresize = {JSR, wm_actli, ARESIZE};
volatile sector myarea;
struct WM_action ati = {JSR, wm_actli, ATI};

static QD_TEXT(4) flag;
static QD_TEXT(10) sparti[12];
static QD_TEXT(10) lparti[12];
static QD_TEXT(4)  tparti[12];
static QD_TEXT(10) eparti[12];
static QD_TEXT(10) kparti[12];
static QD_TEXT(3)  fparti[12];
static QD_TEXT(10) string_sector;
static QD_TEXT(4)  numero[12];

static QD_TEXTI(magic,"Magic (6002):");
static QD_TEXTI(secto,"Sector#");
static QD_TEXTI(activ,"A.");
static QD_TEXTI(label,"Label");
static QD_TEXTI(start,"Start");
static QD_TEXTI(longu,"Length");
static QD_TEXTI(end,"Next free");
static QD_TEXTI(taille,"Size");
static QD_TEXTI(slot,"Slot");
main()
{
   static struct WM_info etiqu[9+1]=
  {
 { 13*6,10,0,0,TYP_TEXT,0,{0,0,0},&magic},
 { 6*6,10,28*6,0,TYP_TEXT,0,{2,0,0},&secto},
 { 2*6,10,0,12,TYP_TEXT,0,{1,0,0},&activ},
 { 5*6,10,3*6,12,TYP_TEXT,0,{1,0,0},&label},
 { 5*6,10,10*6,12,TYP_TEXT,0,{1,0,0},&start},
 { 6*6,10,19*6,12,TYP_TEXT,0,{1,0,0},&longu},
 { 9*6,10,28*6,12,TYP_TEXT,0,{3,0,0},&end},
 { 4*6,10,42*6,12,TYP_TEXT,0,{3,0,0},&taille},
 { 4*6,10,49*6,12,TYP_TEXT,0,{4,0,0},&slot},
   {-1}
};
   static struct WM_wstat ws =  /* window status area */
   {
     NULL,                  /* *wwork               point back to work def */
     NULL,                  /* *wdef                this was wdef */
     0,                     /* chid                 chan ID enclosing pointer */
     0,0,0,                 /* swnr, xpos, ypos     sub-window and ptr posn */
     0,0,                   /* kstk, kprs           key stroke and press */
     0,                     /* evnt                 event vector */
     0,0,0,0,               /* xsiz, ysiz, xorg, yorg  */
     0,0,                   /* ptpsx, ptpsy         pointer position (abs) */
     FORM_QL4,0,0,          /* wmode, 2 spare       window mode and spare */

     NULL,                  /* *ciact               current item "action" */
     -1,                    /* citem                current item */
     0,0,0,                 /* cibrw, cipap, cispr  current item attr */
     0,0,0,0,               /* cihxs,ys, cihxo,yo   current item hit area */

     {0,0,0,0,0,0,0,0}      /* litem[40]            loose item status */
   };


#define wind_wid  310+24    /* application sw size */
#define wind_hgt  192
#define xt_wid    40     /* extra width of window */
#define xt_hgt    2
#define tot_wid  wind_wid+xt_wid
#define tot_hgt  wind_hgt+xt_hgt

#define xoff 310+24
#define yoff 2 /* offset for the STANDARD 13 Litem */

#define min_wid  350     /* and limits */
#define min_hgt  196
#define max_wid  2048
#define max_hgt  2048

#define ninfw    0       /* number of information windows */
#define ninfo    0       /* number of information objects */
#define nlitm    6+12*4+2       /* number of loose items */
#define nappl    0       /* number of application sub-windows */

#define gen_wid(a) ((sizeof((a))-1)*6)

   static struct WM_litm litm[nlitm+1] =   /* loose item */
   {
    {24,12,                 /* xsize, ysize         size */
     4+xoff,2+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,K_COEUR,    /* type, skey           type and select key */
     &sp4_coeur,             /* *pobj                pointer to object */
     lit_coeur,              /* item                 item number */
     &acoeur}                /* *pact                pointer to action */

   , {24,12,                 /* xsize, ysize         size */
     4+xoff,2+16+yoff,         /* xorg, yorg           and origin */
     0,1,                   /* xjst, yjst           justification */
     TYP_SPRITE,K_MOVE,    /* type, skey           type and select key */
     &my_sprite[0],             /* *pobj                pointer to object */
     lit_move,              /* item                 item number */
     &amove}                /* *pact                pointer to action */

   , {24,12,                 /* xsize, ysize         size */
     4+xoff,2+16*2+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,K_RESIZE,    /* type, skey           type and select key */
     &my_sprite[1],             /* *pobj                pointer to object */
     lit_resize,              /* item                 item number */
     &aresize}                /* *pact                pointer to action */

   , {24,12,                 /* xsize, ysize         size */
     4+xoff,2+16*3+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,K_ZZZ,    /* type, skey           type and select key */
     &my_sprite[2],             /* *pobj                pointer to object */
     lit_zzz,              /* item                 item number */
     &azzz}                /* *pact                pointer to action */

   , {32,30,                 /* xsize, ysize         size */
     xoff,2+16*5+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,K_WAKE,    /* type, skey           type and select key */
     &sp_clear,             /* *pobj                pointer to object */
     lit_wake,              /* item                 item number */
     &awake}                /* *pact                pointer to action */

   , {32,30,                 /* xsize, ysize         size */
     xoff,2+16*5+36+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &sp_yes,             /* *pobj                pointer to object */
     18,                  /* item                 item number */
     &aupdate}                /* *pact                pointer to action */

   ,{24,10,
    4+6+6*13,2,
    0,0,
    TYP_TEXT,0,
    &flag,
    19,
    &ati},

    {60,10,
    4+6*38,2,
    0,0,
    TYP_TEXT,0,
    &string_sector,
    17,
    &ati},
#define entry(a) \
   {60,10,  \
    4+16+22,12+2+14+14*a, \
    0,0,       \
    TYP_TEXT,0, \
    &sparti[a],20+a*4,&ati}, \
   {60,10, \
    4+16+22+64,12+2+14+14*a,  \
    0,0,         \
    TYP_TEXT,0, \
    &lparti[a],21+a*4,&ati}, \
   {18,10,         \
    4+16,12+2+14+14*a, \
    0,0,           \
    TYP_TEXT,0,     \
    &tparti[a],22+a*4,&ati}, \
   {12,10,      \
    4,12+2+14+14*a, \
    0,0,           \
    TYP_TEXT,0,     \
    &fparti[a],23+a*4,&ati},
    entry(0)
    entry(1)
    entry(2)
    entry(3)
    entry(4)
    entry(5)
    entry(6)
    entry(7)
    entry(8)
    entry(9)
    entry(10)
    entry(11)
   {-1}                    /* end of array */
   };
   static struct WM_info info[12*3+1]=
   {
#define das_info(a) \
   { 60,10, 6,14*a,        \
     TYP_TEXT,0,{0,0,0},&eparti[a]},\
   { 60,10, 64+6,14*a,     \
     TYP_TEXT,0,{0,0,0},&kparti[a]},\
   { 18,10, 128+6,14*a,    \
     TYP_TEXT,0,{0,0,0},&numero[a]},
  das_info(0)
  das_info(1)
  das_info(2)
  das_info(3)
  das_info(4)
  das_info(5)
  das_info(6)
  das_info(7)
  das_info(8)
  das_info(9)
  das_info(10)
  das_info(11)
  {-1}
  };
  static struct WM_infw infw[1+1+1] =
  {
   {130+24,164,170,12+14+2,0,1,(short)0xD2FF,(short)0xECF0,info}
   ,{296+24,24,2,2,0,0,-1,-1,etiqu}
 ,{-1}
  };
   static WM_WSCALE(ninfw+ninfo+nlitm+nappl) wsc =
                               {min_wid,min_hgt,max_wid,max_hgt,2,1,
                                {
                                 {0,0,8,0}, /* Litem(0) */
                                 {0,0,8,0},
                                 {0,0,8,0},

                                 {0,0,8,0},
                                 {0,0,8,0},
                                 {0,0,0,0}

}};

   static struct WM_wwork ww = /* window working definition */
   {
     &ws,                   /* *wstat;              pointer to status area */
     &wsc,                  /* *wscale              this was pointer to WDEF */
     0,                     /* chid                 channel ID */
     NULL,                  /* *pprec               pointer to pointer record */
     0,                     /* psave                pointer position saved */
     0,0,0,0,               /* 4 zero */
     NULL,                  /* *splst               pointer to sprite list */

     tot_wid,tot_hgt,       /* xsize, ysize         size */
     wind_wid-4,10,         /* xorg, yorg           and origin */
     1,                     /* flag                 no clear + shadow */
     1,CL_MBORD,CL_MBACK,   /* borw, borc, papr     border width/clr, paper */
     NULL,                  /* *sprite              pointer to sprite */

     1,CL_MHIGH,            /* curw, curc           current item width/clr */

     CL_MPUNAV,CL_MIUNAV,NULL,NULL,  /* uback, uink, *ublob, *upatt  unavail */
     CL_MPAVBL,CL_MIAVBL,NULL,NULL,  /* aback, aink, *ablob, *apatt  avail */
     CL_MPSLCT,CL_MISLCT,NULL,NULL,  /* sback, sink, *sblob, *spatt  selected */

     NULL,                  /* *help */

     1+1,24+9+12,infw,              /* ninfo, ninob, *pinfo info winds */
     nlitm,litm,            /* nlitm, *plitm        loose items */
     0,NULL                /* nappl  *pappl        appl winds */
   };
   int i;
   for(i=0;i<12;i++)
   {
   char toto[5];int l;
     sprintf(toto,"%2d",i);
     l=strlen(toto);
     QD_STXT(numero[i],toto,l);
   }
   ww.chid=fgetchid(stdout);
   if (!(wm_vectr = (long) wm_findv(ww.chid))) exit (-1);
   ws.wwork = &ww;        /* set cross reference */
   LimitGeometry(&ww,dis_x = DisplayXSize(),dis_y = DisplayYSize());
   wm_prpos (&ww,-1,-1);
   AWAKE(&ww);
   /* wm_wdraw (&ww); */

   
   while (!wm_rptr(&ww))
{
 if (ws.evnt & PT_ZZZZ) {
/* Menu_Button_Text(DefaultColourSet(),&ww,_PROG_NAME); */
Menu_Button_Logo(DefaultColourSet(),&ww,&sp_kcmdevices);
}
 if (ws.evnt & PT_CAN) exit(0);
}
   exit (-1);                                                
}


static int current_choice=0;
/**
*   Loose Menu Item Action routines
**/

long ACT(wwk,li) struct WM_wwork *wwk; struct WM_litm *li;
{
   return li->skey+14;      /* calculate event for selection key */
}


static long AMOVE(wwk) struct WM_wwork *wwk;
{
   short dx,dy;
   wwk->wstat->evnt |= PT_WMOVE;   /* set event bit for wm_chwin */
   wm_chwin (wwk,&dx,&dy);         /* move window */
   return lit_reset (wwk,lit_move); /* and return */
}
static void update_strings()
{
   int i,l;
    char toto[16];
   l=sprintf(toto,"%4x",myarea.tag);
   QD_STXT(flag,toto,l);
   l=sprintf(toto,"%d",sectornumber);
   QD_STXT(string_sector,toto,l);
   for(i=0;i<4;i++)
   {
     sprintf(toto,"%d",myarea.classic_part[i].start);
     l=strlen(toto);
     QD_STXT(sparti[i],toto,l);
     sprintf(toto,"%d",myarea.classic_part[i].length);
     l=strlen(toto);
     QD_STXT(lparti[i],toto,l);
     sprintf(toto,"%d k",myarea.classic_part[i].length/2);
     l=strlen(toto);
     QD_STXT(kparti[i],toto,l);

     sprintf(toto,"%d",myarea.classic_part[i].start+myarea.classic_part[i].length);
     l=strlen(toto);
     QD_STXT(eparti[i],toto,l);
     sprintf(toto,"%c%c%c",myarea.classic_part[i].type[0],
                           myarea.classic_part[i].type[1],
                           myarea.classic_part[i].type[2]);
     l=strlen(toto);
     QD_STXT(tparti[i],toto,l);
     sprintf(toto,"%2x",myarea.classic_part[i].flag);
     l=strlen(toto);
     QD_STXT(fparti[i],toto,l);
   }
   for(i=0;i<8;i++)
   {
     sprintf(toto,"%d",myarea.icd_part[i].start);
     l=strlen(toto);
     QD_STXT(sparti[i+4],toto,l);
     sprintf(toto,"%d",myarea.icd_part[i].length);
     l=strlen(toto);
     QD_STXT(lparti[i+4],toto,l);
     sprintf(toto,"%d k",myarea.icd_part[i].length/2);
     l=strlen(toto);
     QD_STXT(kparti[i+4],toto,l);

     sprintf(toto,"%d",myarea.icd_part[i].start+myarea.icd_part[i].length);
     l=strlen(toto);
     QD_STXT(eparti[i+4],toto,l);
     sprintf(toto,"%c%c%c",myarea.icd_part[i].type[0],
                           myarea.icd_part[i].type[1],
                           myarea.icd_part[i].type[2]);
     l=strlen(toto);
      QD_STXT(tparti[i+4],toto,l);
     sprintf(toto,"%2x",myarea.icd_part[i].flag);
     l=strlen(toto);
     QD_STXT(fparti[i+4],toto,l);
  }
}

static long AWAKE(wwk) struct WM_wwork *wwk;
{

   int fd,i,l;
   char toto[16];
   fd = open("win1_*d2d",O_RDONLY);
   lseek(fd,sectornumber,SEEK_START); /* that's a very special file */
   read(fd,&myarea,512);
   close(fd);
   update_strings();


   wm_wdraw(wwk);
   return lit_reset (wwk,lit_wake); /* and return */
}

static long AZZZ(wwk) struct WM_wwork *wwk;
 { 
   lit_reset(wwk,lit_zzz);
   return PT__ZZZZ;
 }

static long ACOEUR(wwk) struct WM_wwork *wwk;
 {
          lit_reset(wwk,lit_coeur);
          exit(0);
          return 0;
}
static long ARESIZE(wwk) struct WM_wwork *wwk;
 {
          lit_reset(wwk,lit_resize);
          return PT__WSIZ;
}
static long AUPDATE(struct wm_wwork * wwk, struct WM_litm *li,struct WM_wstat *wst)
{
   long ret;
   ret = XDialog(DefaultColourSet(),"Warning","You are going\nto write\non the disk\n\nThis is your\nlast chance!",
                &sp_cdwriter_mount,0);
   if (!ret)
   {

   int fd;
   fd = open("win1_*d2d",O_WRONLY);
   lseek(fd,sectornumber,SEEK_START); /* that's a very special file */
   write(fd,&myarea,512);
   close(fd);

      Message_Report(DefaultColourSet(),"Too late to be sorry now!");
   }
          lit_reset(wwk,li->item);
          return 0;
}

static long ATI(struct wm_wwork * wwk, struct WM_litm *li,struct WM_wstat *wst)
{
 int ligne,wha;
 long ret;
 unsigned long val;
 char string[12];
 partition *entry;
 switch(li->item)
 {
  case 17:
     sprintf(string,"%d",sectornumber);
     ret = String_Edit(DefaultColourSet(),"Sector #",
        "Sector position",
        string,5,string);
         if (ret != -1)
         {
            sscanf(string,"%d",&ret);
            sectornumber = ret;
            update_strings();
         }
     break;
  case 19:
     sprintf(string,"%x",myarea.tag);
     ret = String_Edit(DefaultColourSet(),"Magic",
        "First short of sector\nMagic value 6002 (in hex)\nto validate the sector as partition description",
        string,5,string);
         if (ret != -1)
         {
            sscanf(string,"%x",&ret);
            myarea.tag = ret;
            update_strings();
         }

     break;
  default:
     ligne = li->item-20;
     wha = ligne%4;
     ligne /=4;
     if (ligne<4)
     {
       entry = &myarea.classic_part[ligne];
     }
     else
     {
       entry = &myarea.icd_part[ligne-4];
     }
     switch(wha)
     {
       case 0:
         sprintf(string,"%d",entry->start);
         ret = String_Edit(DefaultColourSet(),"First sector",
             "Index of first sector\nAvoid overwriting sector 0!\nCheck that there is no overlap too",
               string,10,string);
         if (ret != -1)
         {
            sscanf(string,"%d",&ret);
            entry->start = ret;
         }

         break;
       case 2:
         sprintf(string,"%c%c%c",entry->type[0],entry->type[1],entry->type[2]);
         ret = String_Edit(DefaultColourSet(),"Label",
                "QWA for SMSQ/E, XGM for extended partition\nLNX / SWP for Linux\nOther values as on Atari! (GEM/BGM)",
                string,3,string);
         if (ret != -1)
         {
            entry->type[0] = string[0];
            entry->type[1] = string[1];
            entry->type[2] = string[2];

         }
         break;
       case 1:
         sprintf(string,"%d",entry->length);
         ret = String_Edit(DefaultColourSet(),"Length",
             "Size in 512 byte sectors\nLimit yourself to 524287 for SMSQ/E",
               string,10,string);
         if (ret != -1)
         {
            sscanf(string,"%d",&ret);
            entry->length = ret;
         }

         break;
       case 3:  /* flag */
         sprintf(string,"%d",entry->flag);
         ret = String_Edit(DefaultColourSet(),"Activation",
             "LSB: activated\nMSB: Bootable (not useful for SMSQ/E)\nTypical value: 1\n\nValue in base 10!",
               string,3,string);
         if (ret != -1)
         {
            sscanf(string,"%ud",&val);
            entry->flag = (0x00000ff & val);
         }
         break;
     }
     update_strings();
     break;
 }
    lit_reset(wwk,li->item);
  wm_wdraw (wwk);
 
return AHIT_NORMAL;
}
