/* Loose Menu Item Utilities */
#include <qdos.h>
#include <qptr.h>

/***** Standard Loose Menu Item Action Event Function *****/

long lit_event (wwk,li) struct WM_wwork *wwk; struct WM_litm *li;
{
   return li->skey+14;   /* calculate event for selection key */
}


/***** Standard Loose Menu Item Reset Routine *****/

long lit_reset ( struct WM_wwork *wwk, short lit)
{
   wwk->wstat->litem[lit] = WSI_MKAV;   /* set make available */
   return wm_ldraw (wwk,-1);            /* and re-draw */

   /* contrary to the documentation WM.LDRAW clears the re-draw flags
      so we do not need to reset the item status ourselves after wm_ldraw */
}

/***** Standard Loose Menu Item Action: Reset Item / Return Event *****/

long lit_resev (wwk,li) struct WM_wwork *wwk; struct WM_litm *li;
{
   lit_reset (wwk,li->item);
   return li->skey+14;   /* calculate event for selection key */
}
